Parametrized_Classes_in_ENC shouldn't be TRUE by default

01/17/2013 06:09 AM - Romain Vrignaud

Status: Rejected   

Priority: Normal   

Assignee:    

Category: Puppet integration   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

As Parametrized_Classes_in_ENC is able

to change puppet behavior, I strongly

recommands that this function is not activated

by default during Foreman's migration.

Related issues:

Related to Foreman - Feature #1995: Enable parameterized class support by def... Closed 12/04/2012

History

#1 - 01/17/2013 06:48 AM - Dominic Cleal

- Category set to Puppet integration

- Status changed from New to Feedback

- Priority changed from High to Normal

The issue is a change in the ENC output between the array (which was alphabetical) and the hash (which is effectively random) causes Puppet to

parse manifests in a different order.  In this case, a hosts::server class referenced a variable in hosts, but didn't explicitly include hosts.  When the

ENC output order changed, hosts::server was parsed first and couldn't resolve the variable.  The fix is a manifest change to explicitly include it.

Roman's argument is that this is a bad default if it can cause behavioural changes during upgrades.

I think this should definitely be enabled for fresh installs, but can possibly see the argument for an upgrade.  I'd much rather it was left on and

documented in release notes with other breaking changes.

#2 - 02/27/2014 03:40 PM - Benjamin Papillon

- Description updated

- Status changed from Feedback to Rejected

This bug has no meaning anymore, development went ahead that point.
